SystemOrganization addCategory: #DiggFeed!

Object subclass: #DFDiggArea
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiggFeed'!

DFDiggArea subclass: #DFAllDiggContent
	instanceVariableNames: 'topic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiggFeed'!

!DFAllDiggContent class methodsFor: 'accessing-description' stamp: 'pmm 8/26/2006 14:07'!
descriptionTopic
	^(MASingleOptionDescription selector: #topic label: 'Topic' priority: 100)
		options: DFFeedWidget topics;
		beRequired;
		yourself! !

!DFAllDiggContent methodsFor: 'accessing' stamp: 'pmm 8/26/2006 12:55'!
topic
	^topic! !

!DFAllDiggContent methodsFor: 'accessing' stamp: 'pmm 8/26/2006 12:55'!
topic: aString
	topic := aString! !

!DFAllDiggContent methodsFor: 'accessing' stamp: 'pmm 8/26/2006 13:59'!
topicFolder
	^DFFeedWidget topicsDictionary at: self topic! !

DFAllDiggContent subclass: #DFAllStories
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiggFeed'!

!DFAllStories class methodsFor: 'accessing' stamp: 'pmm 8/26/2006 12:58'!
label
	^'All Stories'! !

!DFAllStories methodsFor: 'accessing' stamp: 'pmm 8/26/2006 14:02'!
baseUrl
	^self diggBaseUrl, 'front/', self topicFolder, '/'! !

DFAllDiggContent subclass: #DFPopularStories
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiggFeed'!

!DFPopularStories class methodsFor: 'accessing' stamp: 'pmm 8/26/2006 12:58'!
label
	^'Popular Stories'! !

!DFPopularStories methodsFor: 'accessing' stamp: 'pmm 8/26/2006 14:03'!
baseUrl
	^self diggBaseUrl, 'submitted/', self topicFolder, '/'! !

!DFDiggArea methodsFor: 'accessing' stamp: 'pmm 8/26/2006 18:09'!
baseUrl
	self subclassResponsibility ! !

!DFDiggArea methodsFor: 'accessing' stamp: 'pmm 8/26/2006 18:09'!
diggBaseUrl
	^'http://digg.com/diggjs/'! !

DFDiggArea subclass: #DFUserContent
	instanceVariableNames: 'type user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiggFeed'!

!DFUserContent class methodsFor: 'accessing-description' stamp: 'pmm 8/26/2006 14:11'!
descriptionType
	^(MASingleOptionDescription selector: #type label: 'Type' priority: 100)
		options: self types
		beRequired;
		yourself! !

!DFUserContent class methodsFor: 'accessing-description' stamp: 'pmm 8/26/2006 14:10'!
descriptionUser
	^(MAStringDescription selector: #user label: 'User' priority: 200)
		beRequired;
		yourself! !

!DFUserContent class methodsFor: 'accessing' stamp: 'pmm 8/26/2006 14:07'!
typeDictionary
	^Dictionary new
		at: 'are popular' put: 'homepage';
		at: 'submitted' put: 'submitted';
		at: 'dugg' put: 'dugg';
		at: 'commented on' put: 'commented';
		yourself! !

!DFUserContent class methodsFor: 'accessing' stamp: 'pmm 8/26/2006 13:01'!
types
	^#(
		'are popular'
		'submitted'
		'dugg'
		'commented on'
	)! !

!DFUserContent methodsFor: 'accessing' stamp: 'pmm 8/26/2006 14:12'!
baseUrl
	^self diggBaseUrl, '/user/', self typeFolder, '/', self user, '/'! !

!DFUserContent methodsFor: 'accessing' stamp: 'pmm 8/26/2006 14:08'!
type
	^type! !

!DFUserContent methodsFor: 'accessing' stamp: 'pmm 8/26/2006 14:08'!
type: aString
	type := aString! !

!DFUserContent methodsFor: 'accessing' stamp: 'pmm 8/26/2006 14:08'!
typeFolder
	^self class typeDictionary at: self type! !

!DFUserContent methodsFor: 'accessing' stamp: 'pmm 8/26/2006 14:09'!
user
	^user! !

!DFUserContent methodsFor: 'accessing' stamp: 'pmm 8/26/2006 14:09'!
user: aString
	user := aString! !

PRBoxWidget subclass: #DFFeedWidget
	instanceVariableNames: 'diggArea typeOfContent numberOfStories displayAs openInNewWindow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiggFeed'!

!DFFeedWidget commentStamp: 'pmm 8/24/2006 23:20' prior: 0!
http://jzencovich.blogspot.com/2006/07/hacking-digg-api-part-i.html
<div class="digg">
	<script>digg_url='http://digg.com/tech_news/Open_Source_Lab_Rackathon_2006';</script>
	<script src="http://digg.com/api/diggthis.js"></script>
</div>

http://digg.com/add-digg
http://www.sourcelabs.com/blogs/ajb/2006/05/digg_this_button_on_your_own_s_1.html
http://sandbox.sourcelabs.com/diggbutton/generate.php!

!DFFeedWidget class methodsFor: 'accessing-description' stamp: 'pmm 8/26/2006 13:57'!
descriptionDiggArea
	^(MAToOneRelationDescription selector: #diggArea label: 'Type of Content' priority: 300)
		classes: (Array
			with: DFAllStories
			with: DFPopularStories
			with: DFUserContent);
		beRequired;
		yourself! !

!DFFeedWidget class methodsFor: 'accessing-description' stamp: 'pmm 8/26/2006 11:17'!
descriptionDisplayAs
	^(MASingleOptionDescription selector: #displayAs label: 'Display As' priority: 600)
		options: self displayModes;
		beRequired;
		yourself! !

!DFFeedWidget class methodsFor: 'accessing-description' stamp: 'pmm 8/26/2006 18:07'!
descriptionNumberOfStories
	^(MASingleOptionDescription selector: #numberOfStories label: 'Number of Stories' priority: 500)
		options: self numbersOfStories;
		reference: MANumberDescription new;
		beRequired;
		yourself! !

!DFFeedWidget class methodsFor: 'accessing-description' stamp: 'pmm 8/26/2006 11:18'!
descriptionOpenInNewWindow
	^(MABooleanDescription selector: #openInNewWindow label: 'Open Link in New Window' priority: 700)
		beRequired;
		yourself! !

!DFFeedWidget class methodsFor: 'accessing-description' stamp: 'pmm 8/26/2006 11:17'!
descriptionTypeOfContent
	^(MASingleOptionDescription selector: #typeOfContent label: 'Type of Content' priority: 400)
		options: self typesOfContent;
		beRequired;
		yourself! !

!DFFeedWidget class methodsFor: 'accessing' stamp: 'pmm 8/26/2006 11:14'!
displayModes
	^#(
		'Bullet List'
		'Div Tags'
	)! !

!DFFeedWidget class methodsFor: 'testing' stamp: 'pmm 8/24/2006 19:50'!
isAbstract
	^false! !

!DFFeedWidget class methodsFor: 'accessing' stamp: 'pmm 8/24/2006 19:51'!
label
	^ 'Digg Feed'! !

!DFFeedWidget class methodsFor: 'accessing' stamp: 'pmm 8/26/2006 11:13'!
numbersOfStories
	^#(
		5
		10
		15
		20
	)! !

!DFFeedWidget class methodsFor: 'accessing' stamp: 'pmm 8/26/2006 12:05'!
topics
	^#(
		'All Topics'
		'Apple'
		'Tech Deals'
		'Gaming News'
		'Hardware'
		'Linux/Unix'
		'Mods'
		'Movies'
		'Music'
		'Software'
		'Tech Industry News'
		'Security'
		'Design'
		'General Sciences'
		'Programming'
		'Gadgets'
		'Business & Finance'
		'Political News'
		'World News'
		'Offbeat News'
		'Celebrity'
		'Television'
		'Playable Web Games'
		'Space'
		'Environment'
		'Health'
		'Animation Videos'
		'Comedy Videos'
		'Educational Videos'
		'Music Videos'
		'People Videos'
		'Gaming Videos'
		'Baseball'
		'Basketball'
		'Extreme'
		'American & Canadian Football'
		'Golf'
		'Hockey'
		'Motorsport'
		'Soccer'
		'Tennis'
		'Other Sports'
		'Political Opinion'
		'Sports Videos'
	)! !

!DFFeedWidget class methodsFor: 'accessing' stamp: 'pmm 8/26/2006 12:05'!
topicsDictionary
	^Dictionary new
		at: 'All Topics' put: 'all';
		at: 'Apple' put: 'apple';
		at: 'Tech Deals' put: 'tech_deals';
		at: 'Gaming News' put: 'gaming_news';
		at: 'Hardware' put: 'hardware';
		at: 'Linux/Unix' put: 'linux_unix';
		at: 'Mods' put: 'mods';
		at: 'Movies' put: 'movies';
		at: 'Music' put: 'music';
		at: 'Software' put: 'software';
		at: 'Tech Industry News' put: 'tech_news';
		at: 'Security' put: 'security';
		at: 'Design' put: 'design';
		at: 'General Sciences' put: 'general_sciences';
		at: 'Programming' put: 'programming';
		at: 'Gadgets' put: 'gadgets';
		at: 'Business & Finance' put: 'business_finance';
		at: 'Political News' put: 'politics';
		at: 'World News' put: 'world_news';
		at: 'Offbeat News' put: 'offbeat_news';
		at: 'Celebrity' put: 'celebrity';
		at: 'Television' put: 'television';
		at: 'Playable Web Games' put: 'playable_web_games';
		at: 'Space' put: 'space';
		at: 'Environment' put: 'environment';
		at: 'Health' put: 'health';
		at: 'Animation Videos' put: 'videos_animation';
		at: 'Comedy Videos' put: 'videos_comedy';
		at: 'Educational Videos' put: 'videos_educational';
		at: 'Music Videos' put: 'videos_music';
		at: 'People Videos' put: 'videos_people';
		at: 'Gaming Videos' put: 'videos_gaming';
		at: 'Baseball' put: 'baseball';
		at: 'Basketball' put: 'basketball';
		at: 'Extreme' put: 'extreme_sports';
		at: 'American & Canadian Football' put: 'football';
		at: 'Golf' put: 'golf';
		at: 'Hockey' put: 'hockey';
		at: 'Motorsport' put: 'motorsport';
		at: 'Soccer' put: 'soccer';
		at: 'Tennis' put: 'tennis';
		at: 'Other Sports' put: 'other_sports';
		at: 'Political Opinion' put: 'political_opinion';
		at: 'Sports Videos' put: 'videos_sports';
		yourself! !

!DFFeedWidget class methodsFor: 'accessing' stamp: 'pmm 8/26/2006 11:12'!
typesOfContent
	^#(
		'Titles and Descriptions'
		'Titles Only'
	)! !

!DFFeedWidget methodsFor: 'accessing' stamp: 'pmm 8/26/2006 13:56'!
diggArea
	^diggArea! !

!DFFeedWidget methodsFor: 'accessing' stamp: 'pmm 8/26/2006 13:56'!
diggArea: aDiggArea
	diggArea := aDiggArea! !

!DFFeedWidget methodsFor: 'accessing' stamp: 'pmm 8/26/2006 13:02'!
displayAs
	^displayAs! !

!DFFeedWidget methodsFor: 'accessing' stamp: 'pmm 8/26/2006 13:03'!
displayAs: aString
	displayAs := aString! !

!DFFeedWidget methodsFor: 'accessing-offset' stamp: 'pmm 8/26/2006 18:09'!
displayAsOffset
	^(self class displayModes indexOf: self displayAs) - 1 * 8! !

!DFFeedWidget methodsFor: 'accessing' stamp: 'pmm 8/26/2006 14:01'!
feedUrl
	^self diggArea baseUrl, self totalOffset displayString! !

!DFFeedWidget methodsFor: 'accessing' stamp: 'pmm 8/26/2006 13:02'!
numberOfStories
	^numberOfStories! !

!DFFeedWidget methodsFor: 'accessing' stamp: 'pmm 8/26/2006 13:02'!
numberOfStories: anInteger
	numberOfStories := anInteger! !

!DFFeedWidget methodsFor: 'accessing-offset' stamp: 'pmm 8/26/2006 13:50'!
numberOfStoriesOffset
	^(self class numbersOfStories indexOf: self numberOfStories) - 1 * 2! !

!DFFeedWidget methodsFor: 'accessing' stamp: 'pmm 8/26/2006 13:03'!
openInNewWindow
	^openInNewWindow! !

!DFFeedWidget methodsFor: 'accessing' stamp: 'pmm 8/26/2006 13:03'!
openInNewWindow: aBoolean
	openInNewWindow := aBoolean! !

!DFFeedWidget methodsFor: 'accessing-offset' stamp: 'pmm 8/26/2006 13:52'!
openInNewWindowOffset
	^self openInNewWindow
		ifTrue: [ 16 ]
		ifFalse: [ 0 ]! !

!DFFeedWidget methodsFor: 'rendering' stamp: 'pmm 8/26/2006 17:43'!
renderDiggScriptOn: html
	html script
		url: self feedUrl;
		with: '' "stupid fucking seaside"! !

!DFFeedWidget methodsFor: 'rendering' stamp: 'pmm 3/4/2007 18:01'!
renderSettingsLinkOn: html
	"copy pasted from PRCommandsWidget"
	html anchor
		accessKey: PRComponentSettings accessKey;
		goto: (self context
			structure: self context structure
			command: PRComponentSettings new);
		with: PRComponentSettings shortLabel! !

!DFFeedWidget methodsFor: 'rendering' stamp: 'pmm 8/26/2006 17:44'!
renderWidgetOn: html
	self diggArea isNil
		ifTrue: [ self renderSettingsLinkOn: html ]
		ifFalse: [ self renderDiggScriptOn: html ]
	! !

!DFFeedWidget methodsFor: 'accessing-offset' stamp: 'pmm 8/26/2006 13:53'!
totalOffset
	^self typeOfContentOffset
		+ self numberOfStoriesOffset
		+ self displayAsOffset
		+ self openInNewWindowOffset
	! !

!DFFeedWidget methodsFor: 'accessing' stamp: 'pmm 8/26/2006 11:11'!
typeOfContent
	^typeOfContent! !

!DFFeedWidget methodsFor: 'accessing' stamp: 'pmm 8/26/2006 11:11'!
typeOfContent: aString
	typeOfContent := aString! !

!DFFeedWidget methodsFor: 'accessing-offset' stamp: 'pmm 8/26/2006 13:04'!
typeOfContentOffset
	^(self class typesOfContent indexOf: self typeOfContent) - 1! !
